package net.knarcraft.placeholdersigns.config;

import org.jetbrains.annotations.NotNull;

/**
 * Permissions used by placeholdersigns
 */
public enum PlaceholderSignsPermission {

    /**
     * The permission for bypassing the restriction on pasting onto waxed signs
     */
    BYPASS_WAXED_COPY("placeholdersigns.copy.bypass-waxed"),

    /**
     * The permission for bypassing the restriction on editing waxed signs
     */
    BYPASS_WAXED_EDIT("placeholdersigns.edit.bypass-waxed"),

    /**
     * The permission for creating new placeholder signs
     */
    USE_PLACEHOLDERS("placeholdersigns.placeholder"),
    ;

    private final @NotNull String permissionNode;

    /**
     * Instantiates a new placeholder signs permission
     *
     * @param permissionNode <p>The permission node belonging to this permission</p>
     */
    PlaceholderSignsPermission(@NotNull String permissionNode) {
        this.permissionNode = permissionNode;
    }

    /**
     * Gets this permission's permission node
     *
     * @return <p>This permission's permission node</p>
     */
    @NotNull
    public String getPermissionNode() {
        return this.permissionNode;
    }

}
