package net.knarcraft.placeholdersigns.container;

import org.jetbrains.annotations.NotNull;

/**
 * A placeholder sign that's queued to be updated
 *
 * @param placeholderSign <p>The queued placeholder sign</p>
 * @param updateTimestamp <p>The timestamp (long milliseconds) that the placeholder sign should be updated at</p>
 */
public record QueuedPlaceholderSign(@NotNull PlaceholderSign placeholderSign,
                                    long updateTimestamp) implements Comparable<QueuedPlaceholderSign> {

    @Override
    public int compareTo(@NotNull QueuedPlaceholderSign other) {
        return Long.compare(this.updateTimestamp, other.updateTimestamp);
    }

}
